/***************************************************************************
                          editor.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef EDITOR_H
#define EDITOR_H

#include "resources.h"
#include "global_types.h"

/**
  *@author funthing (Matthias Zisler)
  */
class Auriferous;
class Timer;
class Wheel;
class Button;

class Editor
{
public: 
	Editor(Auriferous* _app);
	~Editor();

	void run();

private:

	void draw_gui();
	void act();
	void draw_map();

	void save_map();
	void load_map();

  void adjust_world();
  void select();
  void paint();
  void erase();
  void reset();

  CL_String pencil;
  CL_String Turflayer[30][21];
  CL_String Toollayer[30][21];

  CL_Surface* sur;
  CL_Surface* bg;

  int menu;
  int mx, my;
  bool turf;
  WorldType wt;

  Wheel *wh;
  Button *load;
  Button *save;
  Button *add;
  Button *sworld;

  Wheel *wh1;
  Wheel *wh2;
  Button *ok;
  bool c;

  Timer *timer;
	Auriferous* app;
};

#endif
