/***************************************************************************
                          gameobject.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "gameobject.h"
#include "game.h"
#include "map.h"
#include "map_sample.h"
#include "timer.h"
#include "maptile.h"

Gameobject::Gameobject(int _x, int _y, Map_Sample* _sample)
{
	x=_x;
	y=_y;
	sample=_sample;
	del_me=false;
	timer=new Timer;
	speed=0;

	sample->objects.push_back(this);
}
Gameobject::~Gameobject()
{
}
void Gameobject::set_delme()
{
	if(got!=PLAYER) //you can't play without a player?
	del_me=true;
}
void Gameobject::set_bbomb()
{
	if(got!=PLAYER && got!=DUMMYG && got!=MONK)
	del_me=true;
}
bool Gameobject::delete_me()
{
	return del_me;
}
GameobjectType Gameobject::get_type()
{
	return got;
}
void Gameobject::set_pos(int sx, int sy)
{
	x=sx;
	y=sy;
}
int Gameobject::get_x()
{
	return x;
}
int Gameobject::get_y()
{
	return y;
}
int Gameobject::map_x()
{
	return (x/32)*32;
}
int Gameobject::map_y()
{
	return (y/32)*32;
}
int Gameobject::map_x(int off)
{
	return ((x+off)/32)*32;
}
int Gameobject::map_y(int off)
{
	return ((y+off)/32)*32;
}
void Gameobject::move(DirType _dir, float speed)
{
	dir=_dir;

	switch(dir)
	{
	case LEFT:
		x-=(int)(speed*timer->time_elapsed());
	break;
	case RIGHT:
		x+=(int)(speed*timer->time_elapsed());
	break;
	case UP:
		if(y-(int)(speed*timer->time_elapsed())>=32)
		y-=(int)(speed*timer->time_elapsed());
	break;
	case DOWN:
		y+=(int)(speed*timer->time_elapsed());
	}
}

Dummy::Dummy(int _x, int _y, Map_Sample* _sample) : Gameobject(_x, _y, _sample)
{
	got=DUMMYG;
}
Dummy::~Dummy()
{
}
bool Gameobject::block_left()
{
  return sample->map->get_maptile(map_x(16)-32, map_y(16))->is_blocking();
}
bool Gameobject::block_right()
{
  return sample->map->get_maptile(map_x(16)+32, map_y(16))->is_blocking();
}
bool Gameobject::block_up()
{
  return sample->map->get_maptile(map_x(16), map_y(16)-32)->is_blocking();
}
bool Gameobject::block_down()
{
  return sample->map->get_maptile(map_x(16), map_y()+32)->is_blocking();
}
bool Gameobject::on_ladder()
{
  if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==LADDER)
  return 1;
  else
  return 0;
}
bool Gameobject::up_ladder()
{
  if(sample->map->get_maptile(map_x(16), map_y(16)+32)->get_type()==LADDER)
  return 1;
  else
  return 0;
}
bool Gameobject::on_bar()
{
  if(sample->map->get_maptile(map_x(16), map_y(16))->get_type()==BAR)
  return 1;
  else
  return 0;
}