/***************************************************************************
                          map.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MAP_H
#define MAP_H
#include "global_types.h"

/**
  *@author funthing (Matthias Zisler)
  */
class Game;
class Maptile;

class Map
{
public: 
	Map(WorldType _wt, Game* _game);
	~Map();

	void act();
	void show();
	void show_olayer();
	void fit();

	list<Maptile*> tiles;

	Maptile* get_maptile(int _x, int _y);
	Maptile* get_up(Maptile* tile);
	Maptile* get_down(Maptile* tile);
	Maptile* get_left(Maptile* tile);
	Maptile* get_right(Maptile* tile);


	int get_max_m();
	void set_max_m(int n);
	WorldType get_wt();

	Game* game;

private:

	Maptile* dummy_tile;
	CL_Surface* sur;
	int max_m;
	WorldType wt;
};

#endif
